<project xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns="http://maven.apache.org/POM/4.0.0" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
	<modelVersion>4.0.0</modelVersion>

	<groupId>tripleo.elijah</groupId>
	<artifactId>elevated-potential</artifactId>
	<packaging>pom</packaging>
	<version>2024.elevated-potential.2</version>
	<name>elevated-potential</name>
	<url>http://github.com/elijah-lang/elevated-potential</url>

	<properties>
		<project.build.outputTimestamp>1</project.build.outputTimestamp>

		<java.version>17</java.version>
		<maven.compiler.source>17</maven.compiler.source>
		<maven.compiler.target>17</maven.compiler.target>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>

		<downloadSources>true</downloadSources>

		<jacoco.version>0.8.9</jacoco.version>
		<guava.version>33.1.0-jre</guava.version>

		<!--
		<buffers.version>0.0.3</buffers.version>
		<range.version>0.0.3b</range.version>
-->

		<maven-compiler-plugin.version>3.8.1</maven-compiler-plugin.version>

		<jdeferred.version>2.0.0</jdeferred.version>

		<!--
		<kotlin.version>1.9.22</kotlin.version>

		<org.eclipse.xtend.lib.version>2.31.0.M3</org.eclipse.xtend.lib.version>
		<xtend-maven-plugin.version>2.31.0.M3</xtend-maven-plugin.version>
-->
	</properties>

	<modules>
		<module>./elevated-potential.base.impl</module>
		<module>./elevated-potential.core.api</module>
		<module>./elevated-potential.core.impl</module>
		<module>./xxx-elijah-core-api</module>
	</modules>

	<dependencies>

		<!-- https://mvnrepository.com/artifact/org.tukaani/xz -->
		<dependency>
			<groupId>org.tukaani</groupId>
			<artifactId>xz</artifactId>
			<version>1.9</version>
		</dependency>

		<!--
		<dependency>
			<groupId>com.google.dagger</groupId>
			<artifactId>dagger</artifactId>
			<version>2.38.1</version>
		</dependency>

		<dependency>
			<groupId>com.google.dagger</groupId>
			<artifactId>dagger-compiler</artifactId>
			<version>2.38.1</version>
			<scope>provided</scope>
		</dependency>
		-->

		<dependency>
			<groupId>org.antlr</groupId>
			<artifactId>antlr-runtime</artifactId>
			<version>3.5.3</version>
		</dependency>

		<!-- https://smallrye.io/smallrye-mutiny/2.5.1/tutorials/getting-mutiny/ -->
		<dependency>
			<groupId>io.smallrye.reactive</groupId>
			<artifactId>mutiny</artifactId>
			<version>2.5.8</version>
		</dependency>


		<dependency>
			<groupId>org.clojure</groupId>
			<artifactId>clojure</artifactId>
			<version>1.11.2</version>
		</dependency>


		<dependency>
			<groupId>org.mockito</groupId>
			<artifactId>mockito-core</artifactId>
			<version>5.11.0</version>
			<scope>test</scope>
		</dependency>

		<!--
				<dependency>
					<groupId>com.github.spotbugs</groupId>
					<artifactId>spotbugs-annotations</artifactId>
					<version>4.7.3</version>
				</dependency>
		-->

		<dependency>
			<groupId>com.gitlab.tripleo1</groupId>
			<artifactId>buffers</artifactId>
			<version>3038ff102c</version>
			<!--
						<groupId>tripleo.buffers</groupId>
						<artifactId>buffers-v1</artifactId>
						<version>0.0.3</version>
			-->
		</dependency>

		<dependency>
			<!--
						<groupId>tripleo.util.range</groupId>
						<artifactId>range-v1</artifactId>
						<version>${range.version}</version>
			-->
			<groupId>com.gitlab.Tripleo</groupId>
			<artifactId>range</artifactId>
			<version>v0.0.3b</version>
		</dependency>


		<dependency>
			<groupId>javax.annotation</groupId>
			<artifactId>javax.annotation-api</artifactId>
			<version>1.3.2</version>
			<scope>compile</scope>
		</dependency>
		<dependency>
			<groupId>org.eclipse.jdt</groupId>
			<artifactId>org.eclipse.jdt.annotation</artifactId>
			<version>2.3.0</version>
			<scope>compile</scope>
		</dependency>

		<dependency>
			<groupId>org.apache.commons</groupId>
			<artifactId>commons-lang3</artifactId>
			<version>3.14.0</version>
			<scope>compile</scope>
		</dependency>

		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>slf4j-simple</artifactId>
			<version>2.0.12</version>
			<scope>compile</scope>
		</dependency>
		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>slf4j-api</artifactId>
			<version>2.0.12</version>
			<scope>compile</scope>
		</dependency>

		<dependency>
			<groupId>com.github.spotbugs</groupId>
			<artifactId>spotbugs-annotations</artifactId>
			<version>4.8.3</version>
			<scope>compile</scope>
		</dependency>
		<dependency>
			<groupId>com.google.guava</groupId>
			<artifactId>guava</artifactId>
			<version>${guava.version}</version>
			<scope>compile</scope>
		</dependency>

		<!--
		<dependency>
			<groupId>org.eclipse.xtend</groupId>
			<artifactId>org.eclipse.xtend.lib</artifactId>
			<version>${org.eclipse.xtend.lib.version}</version>
		</dependency>
		<dependency>
			<groupId>org.eclipse.xtend</groupId>
			<artifactId>org.eclipse.xtend.core</artifactId>
			<version>${org.eclipse.xtend.lib.version}</version>
		</dependency>
-->

		<!-- https://mvnrepository.com/artifact/com.tngtech.archunit/archunit-junit4 -->
		<dependency>
			<groupId>com.tngtech.archunit</groupId>
			<artifactId>archunit-junit4</artifactId>
			<version>1.2.1</version>
			<scope>test</scope>
		</dependency>

		<!-- https://search.maven.org/artifact/io.reactivex.rxjava3/rxjava/3.1.0/jar -->
		<dependency>
			<groupId>io.reactivex.rxjava3</groupId>
			<artifactId>rxjava</artifactId>
			<version>3.1.8</version>
		</dependency>

		<!-- https://mvnrepository.com/artifact/org.reactivestreams/reactive-streams -->
		<dependency>
			<groupId>org.reactivestreams</groupId>
			<artifactId>reactive-streams</artifactId>
			<version>1.0.4</version>
		</dependency>

		<!-- https://mvnrepository.com/artifact/commons-codec/commons-codec -->
		<dependency>
			<groupId>commons-codec</groupId>
			<artifactId>commons-codec</artifactId>
			<version>1.16.1</version> <!-- Use 1.6 for java 1.5 -->
		</dependency>

		<!-- https://mvnrepository.com/artifact/antlr/antlr -->
		<dependency>
			<groupId>antlr</groupId>
			<artifactId>antlr</artifactId>
			<version>2.7.7</version>
		</dependency>

		<dependency>
			<groupId>org.projectlombok</groupId>
			<artifactId>lombok</artifactId>
			<version>1.18.30</version>
			<scope>provided</scope>
		</dependency>
		<dependency>
			<groupId>org.jdeferred.v2</groupId>
			<artifactId>jdeferred-core</artifactId>
			<version>2.0.0</version>
		</dependency>
		<dependency>
			<groupId>org.jetbrains</groupId>
			<artifactId>annotations</artifactId>
			<version>24.1.0</version>
			<scope>compile</scope>
		</dependency>
		<!--
		<dependency>
			<groupId>org.jetbrains.kotlin</groupId>
			<artifactId>kotlin-stdlib-jdk8</artifactId>
			<version>${kotlin.version}</version>
		</dependency>
		<dependency>
			<groupId>org.jetbrains.kotlin</groupId>
			<artifactId>kotlin-test-junit</artifactId>
			<version>${kotlin.version}</version>
			<scope>test</scope>
		</dependency>
-->

		<dependency>
			<groupId>com.google.auto.service</groupId>
			<artifactId>auto-service</artifactId>
			<version>1.1.1</version>
			<optional>true</optional>
		</dependency>

		<dependency>
			<groupId>org.jctools</groupId>
			<artifactId>jctools-core</artifactId>
			<version>4.0.3</version>
		</dependency>


		<dependency>
			<groupId>org.junit.jupiter</groupId>
			<artifactId>junit-jupiter</artifactId>
			<version>5.10.2</version>
			<scope>test</scope>
		</dependency>
	</dependencies>

	<repositories>
		<repository>
			<id>jitpack.io</id>
			<url>https://jitpack.io</url>
		</repository>
	</repositories>

	<build>

		<plugins>
			<!--
						<plugin>
							<groupId>org.projectlombok</groupId>
							<artifactId>lombok-maven-plugin</artifactId>
							<version>1.18.20.0</version>
							<executions>
								<execution>
									<phase>generate-sources</phase>
									<goals>
										<goal>delombok</goal>
									</goals>
								</execution>
							</executions>
						</plugin>
			-->


			<!--
			<plugin>
				<groupId>org.eclipse.xtend</groupId>
				<artifactId>xtend-maven-plugin</artifactId>
				<version>${xtend-maven-plugin.version}</version>

				<executions>
					<execution>
						<goals>
							<goal>compile</goal>
							<goal>testCompile</goal>
						</goals>
						<configuration>
							<outputDirectory>${project.build.directory}/xtend-gen/main</outputDirectory>
							<testOutputDirectory>${project.build.directory}/xtend-gen/test</testOutputDirectory>
						</configuration>
					</execution>
				</executions>
			</plugin>
-->

			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-compiler-plugin</artifactId>
				<version>3.12.1</version>
				<executions>
					<execution>
						<id>default-compile</id>
						<phase>none</phase>
					</execution>
					<execution>
						<id>default-testCompile</id>
						<phase>none</phase>
					</execution>
					<execution>
						<id>compile</id>
						<phase>compile</phase>
						<goals>
							<goal>compile</goal>
						</goals>
					</execution>
					<execution>
						<id>testCompile</id>
						<phase>test-compile</phase>
						<goals>
							<goal>testCompile</goal>
						</goals>
					</execution>
				</executions>
				<configuration>
					<source>${maven.compiler.source}</source>
					<target>${maven.compiler.target}</target>
				</configuration>
			</plugin>
		</plugins>
	</build>

	<!--
	<reporting>
		<plugins>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-checkstyle-plugin</artifactId>
				<version>3.3.0</version>
				<configuration>
					<configLocation>checkstyle.xml</configLocation>
				</configuration>
				<reportSets>
					<reportSet>
						<reports>
							<report>checkstyle</report>
						</reports>
					</reportSet>
				</reportSets>
			</plugin>
		</plugins>
	</reporting>
-->


	<reporting>
		<plugins>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>jdepend-maven-plugin</artifactId>
				<version>2.0</version>
			</plugin>
		</plugins>
	</reporting>
</project>
